summaryrefslogtreecommitdiff
path: root/testscripts
diff options
context:
space:
mode:
authorChristian Muck <christian.muck@bmw.de>2011-09-16 14:37:31 +0200
committerChristian Muck <christian.muck@bmw.de>2011-09-16 14:37:31 +0200
commit3d66b53ceb985014b0ae72cad6cafe8c07325209 (patch)
tree107efb69cc2369c9c080a46b6c0ee0c12fdb2b40 /testscripts
parent101dab1a5261189a13068810ee57fe76b64ad909 (diff)
downloadDLT-daemon-3d66b53ceb985014b0ae72cad6cafe8c07325209.tar.gz
Bugfix [GSW-72] Can't open /etc/rc.d/init.d/functions. Provide versions for different distros
Diffstat (limited to 'testscripts')
-rwxr-xr-xtestscripts/CMakeLists.txt36
-rwxr-xr-xtestscripts/Meego/dlt-daemon.cmake (renamed from testscripts/dltdaemon)23
-rwxr-xr-xtestscripts/Ubuntu/dlt-daemon.cmake172
-rwxr-xr-xtestscripts/dltinfo.sh24
4 files changed, 226 insertions, 29 deletions
diff --git a/testscripts/CMakeLists.txt b/testscripts/CMakeLists.txt
index 28e75f7..16d618f 100755
--- a/testscripts/CMakeLists.txt
+++ b/testscripts/CMakeLists.txt
@@ -34,7 +34,37 @@
#
# @licence end@
########
-
-install(PROGRAMS dltdaemon dltinfo.sh
- DESTINATION bin
+if(UNIX)
+ if(CMAKE_SYSTEM_NAME MATCHES "Linux")
+ if(EXISTS "/etc/issue")
+ FILE(READ "/etc/issue" LINUX_ISSUE)
+ # Fedora case
+ if(LINUX_ISSUE MATCHES "Fedora")
+ set(DISTRIBUTION "Fedora")
+ endif(LINUX_ISSUE MATCHES "Fedora")
+ # Ubuntu case
+ if(LINUX_ISSUE MATCHES "Ubuntu")
+ set(DISTRIBUTION "Ubuntu")
+ endif(LINUX_ISSUE MATCHES "Ubuntu")
+ # Debian case
+ if(LINUX_ISSUE MATCHES "Debian")
+ set(DISTRIBUTION "Debian")
+ endif(LINUX_ISSUE MATCHES "Debian")
+ # Open SuSE case
+ if(LINUX_ISSUE MATCHES "SUSE")
+ set(DISTRIBUTION "SUSE")
+ endif(LINUX_ISSUE MATCHES "SUSE")
+ if(LINUX_ISSUE MATCHES "Meego")
+ set(DISTRIBUTION "Meego")
+ endif(LINUX_ISSUE MATCHES "Meego")
+
+ install(PROGRAMS ${DISTRIBUTION}/dlt-daemon
+ DESTINATION /etc/init.d/
COMPONENT base)
+
+ endif(EXISTS "/etc/issue")
+ endif(CMAKE_SYSTEM_NAME MATCHES "Linux")
+endif(UNIX)
+
+
+
diff --git a/testscripts/dltdaemon b/testscripts/Meego/dlt-daemon.cmake
index baf3b8e..a2e908e 100755
--- a/testscripts/dltdaemon
+++ b/testscripts/Meego/dlt-daemon.cmake
@@ -11,7 +11,7 @@
processname=dlt-daemon
-processpath=/usr/bin
+processpath=@CMAKE_INSTALL_PREFIX@/bin
servicename=dlt-daemon
@@ -19,7 +19,7 @@ servicename=dlt-daemon
start() {
echo -n $"Starting $processname daemon: "
- /usr/bin/dlt-daemon -d
+ @CMAKE_INSTALL_PREFIX@/bin/dlt-daemon -d
}
stop() {
@@ -54,6 +54,25 @@ case "$1" in
;;
status)
status $processname
+ pidofdlt=`pidof $processname`
+ if [ $pidofdlt ]
+ then
+ echo "DLT Deamon is running with PID:$pidofdlt"
+ else
+ echo "DLT Daemon is NOT running"
+ fi
+
+ if [ -f /var/log/messages ]
+ then
+ echo "------- messages ----------------"
+ cat /var/log/messages | grep -a DLT | tail
+ fi
+
+ if [ -f /var/log/syslog ]
+ then
+ echo "------- SYSLOG -------------------"
+ cat /var/log/syslog | grep -a DLT | tail
+ fi
RETVAL=$?
;;
*)
diff --git a/testscripts/Ubuntu/dlt-daemon.cmake b/testscripts/Ubuntu/dlt-daemon.cmake
new file mode 100755
index 0000000..e7ef098
--- /dev/null
+++ b/testscripts/Ubuntu/dlt-daemon.cmake
@@ -0,0 +1,172 @@
+#!/bin/sh
+### BEGIN INIT INFO
+# Provides: dlt-daemon
+# Required-Start: $network $local_fs
+# Required-Stop:
+# Default-Start: 2 3 4 5
+# Default-Stop: 0 1 6
+# Short-Description: <Enter a short description of the sortware>
+# Description: <Enter a long description of the software>
+# <...>
+# <...>
+### END INIT INFO
+
+# Author: root <jeremiah.foster@pelagicore.com>
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+DESC=dlt-daemon # Introduce a short description here
+NAME=dlt-daemon # Introduce the short server's name here
+DAEMON=@CMAKE_INSTALL_PREFIX@/bin/dlt-daemon # Introduce the server's location here
+DAEMON_ARGS="-d" # Arguments to run the daemon with
+PIDFILE=/var/run/$NAME.pid
+SCRIPTNAME=/etc/init.d/$NAME
+
+# Exit if the package is not installed
+[ -x $DAEMON ] || exit 0
+
+# Read configuration variable file if it is present
+[ -r /etc/default/$NAME ] && . /etc/default/$NAME
+
+# Load the VERBOSE setting and other rcS variables
+. /lib/init/vars.sh
+
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
+. /lib/lsb/init-functions
+
+#
+# Function that starts the daemon/service
+#
+do_start()
+{
+ # Return
+ # 0 if daemon has been started
+ # 1 if daemon was already running
+ # 2 if daemon could not be started
+ start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
+ || return 1
+ start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
+ $DAEMON_ARGS \
+ || return 2
+ # Add code here, if necessary, that waits for the process to be ready
+ # to handle requests from services started subsequently which depend
+ # on this one. As a last resort, sleep for some time.
+}
+
+#
+# Function that stops the daemon/service
+#
+do_stop()
+{
+ # Return
+ # 0 if daemon has been stopped
+ # 1 if daemon was already stopped
+ # 2 if daemon could not be stopped
+ # other if a failure occurred
+ start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
+ RETVAL="$?"
+ [ "$RETVAL" = 2 ] && return 2
+ # Wait for children to finish too if this is a daemon that forks
+ # and if the daemon is only ever run from this initscript.
+ # If the above conditions are not satisfied then add some other code
+ # that waits for the process to drop all resources that could be
+ # needed by services started subsequently. A last resort is to
+ # sleep for some time.
+ start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
+ [ "$?" = 2 ] && return 2
+ # Many daemons don't delete their pidfiles when they exit.
+ rm -f $PIDFILE
+ return "$RETVAL"
+}
+
+#
+# Function that sends a SIGHUP to the daemon/service
+#
+do_reload() {
+ #
+ # If the daemon can reload its configuration without
+ # restarting (for example, when it is sent a SIGHUP),
+ # then implement that here.
+ #
+ start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
+ return 0
+}
+
+case "$1" in
+ start)
+ [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC " "$NAME"
+ do_start
+ case "$?" in
+ 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+ 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+ esac
+ ;;
+ stop)
+ [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
+ do_stop
+ case "$?" in
+ 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+ 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+ esac
+ ;;
+ status)
+ if [ -f /var/log/messages ]
+ then
+ log_daemon_msg "------- messages ----------------"
+ cat /var/log/messages | grep -a DLT | tail
+ fi
+
+ if [ -f /var/log/syslog ]
+ then
+ log_daemon_msg "------- SYSLOG -------------------"
+ cat /var/log/syslog | grep -a DLT | tail
+ fi
+
+ status_of_proc "$DAEMON" "$NAME" || exit $?
+
+ pidofdlt=`pidof $DESC`
+ if [ $pidofdlt ]
+ then
+ log_daemon_msg "$NAME has the PID:$pidofdlt"
+ fi
+
+
+ ;;
+ #reload|force-reload)
+ #
+ # If do_reload() is not implemented then leave this commented out
+ # and leave 'force-reload' as an alias for 'restart'.
+ #
+ #log_daemon_msg "Reloading $DESC" "$NAME"
+ #do_reload
+ #log_end_msg $?
+ #;;
+ restart|force-reload)
+ #
+ # If the "reload" option is implemented then remove the
+ # 'force-reload' alias
+ #
+ log_daemon_msg "Restarting $DESC" "$NAME"
+ do_stop
+ case "$?" in
+ 0|1)
+ do_start
+ case "$?" in
+ 0) log_end_msg 0 ;;
+ 1) log_end_msg 1 ;; # Old process is still running
+ *) log_end_msg 1 ;; # Failed to start
+ esac
+ ;;
+ *)
+ # Failed to stop
+ log_end_msg 1
+ ;;
+ esac
+ ;;
+ *)
+ #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
+ echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
+ exit 3
+ ;;
+esac
diff --git a/testscripts/dltinfo.sh b/testscripts/dltinfo.sh
deleted file mode 100755
index 3e70ab5..0000000
--- a/testscripts/dltinfo.sh
+++ /dev/null
@@ -1,24 +0,0 @@
-#!/bin/sh
-clear
-processname="dlt-daemon"
-pidofdlt=`pidof $processname`
-
-if [ $pidofdlt ]
- then
- echo "DLT Deamon is running with PID:$pidofdlt"
- else
- echo "DLT Daemon is NOT running"
-fi
-
-if [ -f /var/log/messages ]
- then
-echo "------- messages ----------------"
-cat /var/log/messages | grep -a DLT | tail
-fi
-
-if [ -f /var/log/syslog ]
- then
- echo "------- SYSLOG -------------------"
- cat /var/log/syslog | grep -a DLT | tail
-fi
-